require '_h2ph_pre.ph';

unless(defined(&_LINUX_KERNEL_H)) {
    eval 'sub _LINUX_KERNEL_H () {1;}' unless defined(&_LINUX_KERNEL_H);
    require 'linux/lidsext.ph';
    if(defined(&__KERNEL__)) {
	require 'stdarg.ph';
	require 'linux/linkage.ph';
	eval 'sub barrier () {
	    eval q( &__asm__  &__volatile__(\\"\\": : :\\"memory\\"));
	}' unless defined(&barrier);
	eval 'sub INT_MAX () {((~0>>1));}' unless defined(&INT_MAX);
	eval 'sub UINT_MAX () {(~0);}' unless defined(&UINT_MAX);
	eval 'sub LONG_MAX () {((~0>>1));}' unless defined(&LONG_MAX);
	eval 'sub ULONG_MAX () {(~0);}' unless defined(&ULONG_MAX);
	eval 'sub STACK_MAGIC () {0xdeadbeef;}' unless defined(&STACK_MAGIC);
	eval 'sub KERN_EMERG () {"<0>";}' unless defined(&KERN_EMERG);
	eval 'sub KERN_ALERT () {"<1>";}' unless defined(&KERN_ALERT);
	eval 'sub KERN_CRIT () {"<2>";}' unless defined(&KERN_CRIT);
	eval 'sub KERN_ERR () {"<3>";}' unless defined(&KERN_ERR);
	eval 'sub KERN_WARNING () {"<4>";}' unless defined(&KERN_WARNING);
	eval 'sub KERN_NOTICE () {"<5>";}' unless defined(&KERN_NOTICE);
	eval 'sub KERN_INFO () {"<6>";}' unless defined(&KERN_INFO);
	eval 'sub KERN_DEBUG () {"<7>";}' unless defined(&KERN_DEBUG);
	eval 'sub NORET_TYPE () {1;}' unless defined(&NORET_TYPE);
	eval 'sub ATTRIB_NORET () { &__attribute__(( &noreturn));}' unless defined(&ATTRIB_NORET);
	eval 'sub NORET_AND () { &noreturn,;}' unless defined(&NORET_AND);
	if(defined(&__i386__)) {
	    eval 'sub FASTCALL {
	        local($x) = @_;
    		eval q($x  &__attribute__(( &regparm(3))));
	    }' unless defined(&FASTCALL);
	} else {
	    eval 'sub FASTCALL {
	        local($x) = @_;
    		eval q($x);
	    }' unless defined(&FASTCALL);
	}
	if((defined(&DEBUG) ? &DEBUG : 0)) {
	    eval 'sub pr_debug () {( &fmt, &arg...)  &printk( &KERN_DEBUG  &fmt, &arg);}' unless defined(&pr_debug);
	} else {
	    eval 'sub pr_debug () {( &fmt, &arg...)  &do { }  &while (0);}' unless defined(&pr_debug);
	}
	eval 'sub pr_info () {( &fmt, &arg...)  &printk( &KERN_INFO  &fmt, &arg);}' unless defined(&pr_info);
	eval 'sub NIPQUAD {
	    local($addr) = @_;
    	    eval q(($addr)[0], ($addr)[1], ($addr)[2], ($addr)[3]);
	}' unless defined(&NIPQUAD);
	eval 'sub security_alert () {( &normal_msg,  &flood_msg,  &args...) ({  &static \'unsigned long warning_time\' = 0,  &no_flood_yet = 0;  &static  &spinlock_t  &security_alert_lock =  &SPIN_LOCK_UNLOCKED;  &spin_lock( &security_alert_lock);  &if (! &warning_time ||  &jiffies -  &warning_time > 60*  &HZ) {  &warning_time =  &jiffies;  &no_flood_yet = 1;  &printk( &KERN_ALERT "Security: "  &normal_msg "\\n",   &args); }  &else  &if ( &no_flood_yet) {  &warning_time =  &jiffies;  &no_flood_yet = 0;  &printk( &KERN_ALERT "Security: more "  &flood_msg ", logging disabled for a minute\\n"); }  &spin_unlock( &security_alert_lock); });}' unless defined(&security_alert);
    }
    eval 'sub SI_LOAD_SHIFT () {16;}' unless defined(&SI_LOAD_SHIFT);
}
1;
