require '_h2ph_pre.ph';

if(defined(&CONFIG_LIDS)) {
    unless(defined(&LIDSEXT_H)) {
	eval 'sub LIDSEXT_H () {1;}' unless defined(&LIDSEXT_H);
	if(defined(&CONFIG_LIDS_DEBUG)) {
	    eval 'sub LIDS_DEBUG () {1;}' unless defined(&LIDS_DEBUG);
	}
	if(defined(&LIDS_DEBUG)) {
	    eval 'sub LIDS_DBG () {( &msg...)  &printk( &KERN_DEBUG "LIDS."  &__FUNCTION__ ": "  &msg);}' unless defined(&LIDS_DBG);
	} else {
	    eval 'sub LIDS_DBG () {( &msg...);}' unless defined(&LIDS_DBG);
	}
	eval 'sub lids_get_current_dentry {
	    local($dentry) = @_;
    	    eval q({ \'struct vm_area_struct\' *  &vma; $dentry =  &NULL;  &if ( ($current->{mm})) {  &vma =  ($current->{mm}->{mmap});  &while ( &vma) {  &if (( ($vma->{vm_flags}) &  &VM_EXECUTABLE)  &&  ($vma->{vm_file})) { $dentry= ($vma->{vm_file}->{f_dentry});  &break; }  &vma =  ($vma->{vm_next}); } } });
	}' unless defined(&lids_get_current_dentry);
	eval 'sub lids_info_params1 () { ($f_dentry->{d_iname}),  &MAJOR( ($f_dentry->{d_inode}->{i_dev})),  &MINOR( ($f_dentry->{d_inode}->{i_dev})),  ($f_dentry->{d_inode}->{i_ino}),  ($current->{pid}),  ($current->{uid}),  ($current->{gid});}' unless defined(&lids_info_params1);
	eval 'sub lids_info_params2 () { ($current->{pid}),  ($current->{uid}),  ($current->{gid});}' unless defined(&lids_info_params2);
	if(defined(&CONFIG_LIDS_HANGUP)) {
	    eval 'sub lids_hangup_console () {
	        eval q( &do{  &if( ($current->{tty}) !=  &NULL  && ! &lids_first_time ) {  &if (! &test_bit( &TTY_LIDS_NO_HANGUP, ($current->{tty}->{flags})) )  &tty_vhangup( ($current->{tty})); } } &while(0));
	    }' unless defined(&lids_hangup_console);
	} else {
	    eval 'sub lids_hangup_console () {
	        eval q( &do {}  &while (0));
	    }' unless defined(&lids_hangup_console);
	}
	if(defined(&CONFIG_LIDS_SA_THROUGH_NET)) {
	    eval 'sub lids_print () {( &message,  &args...)  &sprintf( &p,  &message ,   &args);}' unless defined(&lids_print);
	} else {
	    eval 'sub lids_print () {( &message,  &args...)  &printk( &KERN_ALERT  &message ,   &args);}' unless defined(&lids_print);
	}
	eval 'sub lids_make_alert () {( &message,  &args...)  &if ( &f_dentry  &&  ($f_dentry->{d_inode})) {  &if ( ($current->{tty})) {  &lids_print( "LIDS: %s (%d %d inode %ld) pid %d user (%d/%d) on %s%d: "  &message "\\n",  &lids_info_params1,  ($current->{tty}->{driver}->{name}), (  &MINOR(( ($current->{tty}))-> &device)-  ($current->{tty}->{driver}->{minor_start})+  ($current->{tty}->{driver}->{name_base}) ) ,   &args); }  &else {  &lids_print( "LIDS: %s (%d %d inode %ld) pid %d user (%d/%d) on NULL tty: "  &message "\\n",  &lids_info_params1 ,   &args); } }  &else {  &if ( ($current->{tty})) {  &lids_print( "LIDS:  pid %d user (%d/%d) on %s%d: "  &message "\\n",  &lids_info_params2,  ($current->{tty}->{driver}->{name}), (  &MINOR(( ($current->{tty}))-> &device)-  ($current->{tty}->{driver}->{minor_start})+  ($current->{tty}->{driver}->{name_base}) ) ,   &args); }  &else {  &lids_print( "LIDS:  pid %d user (%d/%d) on NULL tty: "  &message "\\n",  &lids_info_params2 ,   &args); } };}' unless defined(&lids_make_alert);
	if(defined(&CONFIG_LIDS_SA_THROUGH_NET)) {
	    eval 'sub lids_log () {( &message,  &args...) { \'char\' * &p;  &p= &kmalloc(2048, &GFP_KERNEL);  &lids_make_alert( &message ,   &args);  &printk( &KERN_ALERT "%s", &p);  &lids_send_message( &p, &strlen( &p)); };}' unless defined(&lids_log);
	} else {
	    eval 'sub lids_log () {( &message,  &args...)  &lids_make_alert( &message ,   &args);}' unless defined(&lids_log);
	}
	if(defined(&CONFIG_LIDS_NO_FLOOD_LOG)) {
	    eval 'sub lids_security_alert () {( &message,  &args...) ({  &static \'unsigned long warning_time\' = 0,  &no_flood_yet = 0;  &static  &spinlock_t  &lids_security_alert_lock =  &SPIN_LOCK_UNLOCKED; \'struct dentry\' * &f_dentry;  &lids_get_current_dentry( &f_dentry);  &spin_lock( &lids_security_alert_lock);  &if (! &warning_time ||  &jiffies -  &warning_time >  &CONFIG_LIDS_TIMEOUT_AFTER_FLOOD *  &HZ) {  &warning_time =  &jiffies;  &no_flood_yet = 1;  &lids_log( &message ,   &args); }  &else  &if ( &no_flood_yet) {  &warning_time =  &jiffies;  &no_flood_yet = 0;  &lids_log("more "  &message ",logging disabled for %i seconds" ,   &args ,  &CONFIG_LIDS_TIMEOUT_AFTER_FLOOD); }  &spin_unlock( &lids_security_alert_lock);  &lids_hangup_console(); });}' unless defined(&lids_security_alert);
	} else {
	    eval 'sub lids_security_alert () {( &message,  &args...) ({ \'struct dentry\' * &f_dentry;  &static  &spinlock_t  &lids_security_alert_lock =  &SPIN_LOCK_UNLOCKED;  &spin_lock( &lids_security_alert_lock);  &lids_get_current_dentry( &f_dentry);  &lids_log( &message ,   &args);  &spin_unlock( &lids_security_alert_lock);  &lids_hangup_console(); });}' unless defined(&lids_security_alert);
	}
	if(defined(&CONFIG_LIDS_ALLOW_SWITCH)) {
	    eval 'sub lids_local_load () {(  &lids_local_on || (! &lids_local_off()) );}' unless defined(&lids_local_load);
	} else {
	    eval 'sub lids_local_load () {1;}' unless defined(&lids_local_load);
	}
    }
}
1;
